<!DOCTYPE html>
<html xmlns:th="http://www.thymeleaf.org" xmlns="http://www.w3.org/1999/xhtml">

    <head th:replace="fragments/header :: header">
        <title th:text="#{title}">title</title>
    </head>
    <body>

        <!--Start Container-->
        <div id="main" class="container-fluid">
            <div class="row">

                <th:block th:include="fragments/sidebar :: sidebar('naturalPerson')"></th:block>

                <!--Start Content-->
                <div id="content" class="col-xs-12 col-sm-10">

                    <th:block th:include="fragments/about :: about"></th:block>

                    <!-- Preloader -->
                    <th:block th:include="fragments/preloader :: preloader"></th:block>

                    <!--Start Breadcrumb-->
                    <div class="row">
                        <div id="breadcrumb" class="col-xs-12">

                            <a href="#" class="show-sidebar">
                                <i class="fa fa-bars"></i>
                            </a>

                            <th:block th:insert="breadcrumb :: breadcrumb(breadcrumb)">
                                <ol class="breadcrumb pull-left">
                                    <li><a th:text="#{index}" th:href="@{/}" href="index.html">index</a></li>
                                    <li><a th:text="#{label.login}" th:href="@{/login}"
                                           href="login.html">[login]</a></li>
                                </ol>
                            </th:block>

                            <!--
                            <ol class="breadcrumb pull-left">
                                <li><a th:href="@{/}" href="index.html">Index</a></li>
                            </ol>-->
                            <div id="social" class="pull-right">
                                <a href="#"><i class="fa fa-google-plus"></i></a>
                                <a href="#"><i class="fa fa-facebook"></i></a>
                                <a href="#"><i class="fa fa-twitter"></i></a>
                                <a href="#"><i class="fa fa-linkedin"></i></a>
                                <a href="#"><i class="fa fa-youtube"></i></a>
                            </div>
                        </div>
                    </div>
                    <!--End Breadcrumb-->


                    <!--Start Dashboard 2-->
                    <div class="row">
                        <div class="col-xs-12 col-sm-12">

                            <div class="col-lg-12">
                                <th:block th:if="${param.error != null}">
                                    <div th:replace="fragments/alert :: alert (type='danger', message=#{login.error.messaje})">Alert</div>
                                </th:block>
                                <th:block th:if="${param.logout != null}">
                                    <div th:replace="fragments/alert :: alert (type='info', message=#{login.logout.messaje})">Alert</div>
                                </th:block>
                                <th:block th:if="${param.expired != null}">
                                    <div th:replace="fragments/alert :: alert (type='info', message=#{login.expired.messaje})">Alert</div>
                                </th:block>

                                <div class="col-lg-4 col-lg-offset-4">

                                    <div class="page-header">
                                        <h1 th:text="#{login.title}">login.title</h1>
                                    </div>

                                    <form id="f" name="f" th:action="@{/login}" action="/login" method="POST">
                                        <fieldset>
                                            <input id="token" type="hidden" name="token" value="" th:placeholder="#{login.token}"/>
                                        </fieldset>
                                        <button type="button" class="btn btn-primary btn-lg btn-block" id="submit-button" th:text="#{login.button.submit}" onclick="getCertificates()">login.button.submit</button>
                                    </form>
                                </div>
                            </div>

                            <div class="col-lg-12" style="padding-top: 20px">
                                <div id="nexu_missing_alert" style="display:none;" class="alert alert-warning"><span id="warning-text"></span> You can download the <a th:href="${downloadNexuUrl}">open source version of NexU</a> (<a href="http://nowina.lu/news/nexu/">more info</a>)</div>
                                <div id="nexu_ready_alert" style="display:none;" class="alert alert-info" th:text="#{nexu.signature.process.info.message}">nexu.signature.process.info.message</div>
                            </div>

                            <div class="col-lg-12">
                                <h2 th:text="#{nexu.signature.process.title}">nexu.signature.process.title</h2>

                                <div class="progress">
                                    <div class="progress-bar progress-bar-striped active" style="width:0%" id="bar">
                                        <span id="bar-text"></span>
                                    </div>
                                </div>
                                <div id="error" style="display:none" class="alert alert-danger" role="danger">
                                    <strong id="errorText" th:text="#{nexu.signature.process.error.message}">nexu.signature.process.error.message </strong><span id="errorcontent"></span>
                                </div>
                            </div>

                        </div>
                        <div class="clearfix"></div>
                    </div>
                    <!--End Dashboard 2 -->

                </div>
                <div class="clearfix"></div>


            </div>
            <!--End Content-->
        </div>
        <!--End Container-->

        <div th:replace="fragments/js :: js">JavaScript</div>

        <script type="text/javascript" th:src="@{/js/nexu-deploy.js}"></script>

        <script type="text/javascript" th:inline="javascript">
            /*<![CDATA[*/
            var contextRoot = /*[[@{/}]]*/ '';
            var DSS_SERVICES_URL = 'http://127.0.0.1:8095/rest/dss/';
            var signatureParameters = JSON.parse(/*[[${signatureParameters}]]*/ null);
            //var signatureParameters = JSON.parse(parameters);

            window.onload = function () {
                //Valida el estado de Nexu al cargar la pagina
                nexuStartup();
            };

            function test(response) {
                console.log("test " + JSON.stringify(response));
            }

            function getCertificates() {
                updateProgressBar("Loading certificates...", "10%");
                var purpose = 'digitalSignature';
                nexu_get_certificates(purpose, getDataToSign, error);
            }

            function getDataToSign(certificateData) {
                if (certificateData.response === null) {
                    $('#bar').removeClass('progress-bar-success active').addClass('progress-bar-danger');
                    $('#bar-text').html("Error");
                    document.getElementById("errorcontent").innerHTML = "error while reading the Smart Card";
                    $("#error").show();
                } else {
                    updateProgressBar("Computing the digest...", "25%");
                    var signingCertificate = certificateData.response.certificate;
                    var certificateChain = certificateData.response.certificateChain;
                    var encryptionAlgorithm = certificateData.response.encryptionAlgorithm;

                    signatureParameters.signingCertificate = signingCertificate;
                    signatureParameters.certificateChain = certificateChain;
                    signatureParameters.encryptionAlgorithm = encryptionAlgorithm;

                    tokenId = certificateData.response.tokenId.id;
                    keyId = certificateData.response.keyId;
                    var toSend = {signingCertificate: signingCertificate, certificateChain: certificateChain,
                        document: {encodedDocument: signatureParameters.document.encodedDocument, mimeType: signatureParameters.document.mimeType},
                        signWithExpiredCertificate: signatureParameters.signWithExpiredCertificate,
                        signatureLevel: signatureParameters.signatureLevel, signaturePackaging: signatureParameters.signaturePackaging,
                        signatureAlgorithm: signatureParameters.signatureAlgorithm, encryptionAlgorithm: encryptionAlgorithm, digestAlgorithm: signatureParameters.digestAlgorithm,
                        blevelParams: {signingDate: signatureParameters.bLevelParams.signingDate},
                        contentTimestampParameters: {digestAlgorithm: signatureParameters.contentTimestampParameters.digestAlgorithm},
                        signatureTimestampParameters: {digestAlgorithm: signatureParameters.signatureTimestampParameters.digestAlgorithm},
                        archiveTimestampParameters: {digestAlgorithm: signatureParameters.archiveTimestampParameters.digestAlgorithm}};
                    console.log('to data-to-sign: ' + JSON.stringify(toSend));
                    callUrl(DSS_SERVICES_URL + 'data-to-sign', "POST", JSON.stringify(toSend), sign, error);
                }
            }

            function sign(dataToSignResponse) {
                if (dataToSignResponse === null) {
                    $('#bar').removeClass('progress-bar-success active').addClass('progress-bar-danger');
                    $('#bar-text').html("Error");
                    $("#errorcontent").text("unable to compute the data to sign (see server logs)");
                    $("#error").show();
                } else {
                    updateProgressBar("Signing the digest...", "50%");
                    var digestAlgo = signatureParameters.digestAlgorithm;
                    var dataToSign = dataToSignResponse.response.dataToSign;
                    console.log('to sign: ' + JSON.stringify(dataToSignResponse));
                    console.log('to dataToSign ' + dataToSign);
                    nexu_sign_with_token_infos(tokenId, keyId, dataToSign, digestAlgo, signDocument, error);
                }
            }

            function signDocument(signatureData) {
                updateProgressBar("Signing the document...", "75%");
                var signatureValue = signatureData.response.signatureValue;
                var toSend = {signingCertificate: signatureParameters.signingCertificate, certificateChain: signatureParameters.certificateChain,
                    document: {encodedDocument: signatureParameters.document.encodedDocument, mimeType: signatureParameters.document.mimeType},
                    signatureValue: signatureValue,
                    signWithExpiredCertificate: signatureParameters.signWithExpiredCertificate,
                    signatureLevel: signatureParameters.signatureLevel, signaturePackaging: signatureParameters.signaturePackaging,
                    signatureAlgorithm: signatureParameters.signatureAlgorithm, encryptionAlgorithm: signatureParameters.encryptionAlgorithm, digestAlgorithm: signatureParameters.digestAlgorithm,
                    blevelParams: {signingDate: signatureParameters.bLevelParams.signingDate},
                    contentTimestampParameters: {digestAlgorithm: signatureParameters.contentTimestampParameters.digestAlgorithm},
                    signatureTimestampParameters: {digestAlgorithm: signatureParameters.signatureTimestampParameters.digestAlgorithm},
                    archiveTimestampParameters: {digestAlgorithm: signatureParameters.archiveTimestampParameters.digestAlgorithm}};
                console.log('to sign-document ' + JSON.stringify(toSend));
                callUrl(DSS_SERVICES_URL + '/sign-document', "POST", JSON.stringify(toSend), submitForm, error);
            }

            function submitForm(signDocumentResponse) {

                if (signDocumentResponse.response === null) {
                    $('#bar').removeClass('progress-bar-success active').addClass('progress-bar-danger');
                    $('#bar-text').html("Error");
                    $("#errorcontent").text("unable to sibmit the signature to the server (see server logs)");
                    $("#error").show();
                } else {
                    console.log('signed document ' + JSON.stringify(signDocumentResponse));
                    updateProgressBar("Done !", "100%");
                    $('#bar').removeClass('progress-bar-striped active');
                    $('#bar').addClass('progress-bar-success');
                    $("#token").val(signDocumentResponse.response.signedDocument);
                    $("#f").submit();
                }
            }

            /*function getDataToSign(certificateData) {
             console.log("certificateData: " + JSON.stringify(certificateData));
             $("#token").val(certificateData.response.certificate);
             $("#f").submit();
             }*/

            function showAlert(message, type, closeDelay) {
                $("#alerts-container").empty();
                // alerts-container must exist
                // default to alert-info; other options include success, warning, danger
                type = type || "info";
                // create the alert div
                var alert = $('<div class="alert alert-' + type + ' alert-dismissible" role="alert">')
                        .append(
                                $('<button type="button" class="close" data-dismiss="alert" aria-label="Close"> <span class="glyphicon glyphicon-remove" aria-hidden="true"></span> </button>')
                                )
                        .append(message)
                        .append('</div>');
                // add the alert div to top of alerts-container, use append() to add to bottom
                $("#alerts-container").prepend(alert);
                // if closeDelay was passed - set a timeout to close the alert
                if (closeDelay) {
                    window.setTimeout(function () {
                        alert.alert("close")
                    }, closeDelay);
                }
            }

            function error(error) {
                $('#bar').removeClass('progress-bar-success active').addClass('progress-bar-danger');
                if (error != null && error.responseJSON != null) {
                    var jsonResp = error.responseJSON;
                    if (jsonResp.errorMessage != null) {
                        $("#errorcontent").html(jsonResp.errorMessage);
                    }
                    else if (jsonResp.error != null) {
                        $("#errorcontent").html(jsonResp.error);
                    }
                }
                $("#error").show();
                $("#success").hide();
            }

            function updateProgressBar(action, percent) {
                $('#bar-text').html(action);
                $('#bar').width(percent);
            }
            /*]]>*/
        </script>
    </body>
</html>